<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
class Admin extends CI_Controller {
	private $root;
    function __construct()
    {
        parent::__construct();
		$this->load->model('backend/admin_model','admin');
        if(!$this->session->userdata('auth_user_id')) {
            redirect('admin/login');
        }
		$this->root = $this->config->item('root');
		$this->form_validation->set_error_delimiters('<li class="error">', '</li>');
    }
	
	public function index() {
		$current_user_id = $this->session->userdata('auth_user_id');
		//$sql = "select max(timestamp) last_login from event_log where user_id = $current_user_id";
		//$data['last_login'] = $this->db->query($sql)->result()[0]->last_login;
		$data['last_login'] = $this->session->userdata('last_login_date');
		$this->load->view('backend/home_view', $data);
	}

	function page_not_found() {
		$this->load->view('backend/404_view');
	}

	function add_client() {
		$this->form_validation->set_rules('img_title', 'image title', 'required|min_length[3]|max_length[50]');
		$this->form_validation->set_rules('img', 'image', '');
		$this->form_validation->set_rules('publish', 'publish', '');
		
		$data     = array();
		$img_file = FALSE;
		

		if($_POST) {
			// Image 
			$config = array();
			$config['upload_path']   = $this->root.'uploads/images/clients/';
			$config['allowed_types'] = 'jpg|png|gif|jpeg';
			$config['max_width']     = '280';
			$config['max_height']    = '150';
			$config['max_size']      = '512'; // In kilobytes (zero for no limit)
			$config['encrypt_name']  = TRUE;
			
			$this->load->library('upload', $config, 'upload_image_lib');
			if(!$this->upload_image_lib->do_upload('img'))
			{
				$data['img_file_errors'] = array('error' => $this->upload_image_lib->display_errors('<li class="error">', '</li>'));
			}
			else {
				// Resize image
				$uploaded_img = $this->upload_image_lib->data();				
				$img_name     = $uploaded_img['raw_name'];
				$img_ext      = $uploaded_img['file_ext'];
				$img_file     = TRUE;
			}
		}
		
		if($this->form_validation->run() === TRUE && $img_file) {
			$this->upload_image_lib->move_file();
			
			$img_title = $this->input->post('img_title');
			$publish   = ($this->input->post('publish') == 'accept' ? 1 : 0);
			
			if($this->admin->add_client($img_title, $img_name, $img_ext, $publish)) {
				$this->messages->success('The client has been added successfully');	
			} else {
				$this->messages->error('Unknown error occured, try again later');
			}
			redirect('admin/clients');
		}
		$this->load->view('backend/add_client_view', $data);
	}
	
	function clients() {
		$data['clients'] = $this->admin->get_clients();
		$this->load->view('backend/clients_view', $data);
	}
	function delete($item_id, $type) {
		if(empty($item_id) || empty($type)) {
			redirect('admin');
		}
		switch($type) {
			case 1:
				$table       = "news";
				$redirect_to = "news";				
			break;			case 2:				$table       = "emp";				$redirect_to = "team";							break;
			case 3:
				$table       = "clients";
				$redirect_to = "clients";
			break;
		}
		if(!is_numeric($type) || !is_numeric($item_id) || !$this->db->get_where($table, array('id' => $item_id))->num_rows()) {
			redirect('admin');
		}
		if($this->admin->delete($item_id, $type)) {
			$this->messages->success('This item has been deleted successfully');
		}
		else {
			$this->messages->error('Unknown error occured, try again later');
		}
		redirect('/admin/'.$redirect_to);
	}
	function edit_client($client_id) {
		if(!is_numeric($client_id) || !$this->db->get_where('clients', array('id' => $client_id))->num_rows()) {
			redirect('admin');
		}
		$data['client'] = $this->db->get_where('clients', array('id' => $client_id))->row();
		$img_file     = TRUE;
		$this->form_validation->set_rules('img_title', 'img title', 'required|min_length[3]|max_length[50]');
		$this->form_validation->set_rules('publish', 'publish', '');
		$this->form_validation->set_rules('upload_img', ' ', '');
		// Upload new image ???
		$upload_img_check = ($this->input->post('upload_img') == 'accept' ? 1 : 0);
		if($_POST && $upload_img_check) {
			// Image 
			$config = array();
			$config['upload_path']   = $this->root . 'uploads/images/clients/';
			$config['allowed_types'] = 'jpg|png|gif|jpeg';
			$config['max_width']     = '280';
			$config['max_height']    = '150';
			$config['max_size']      = '512'; // In kilobytes (zero for no limit)
			$config['encrypt_name']  = TRUE;
			$this->load->library('upload', $config, 'upload_image_lib');
			if( ! $this->upload_image_lib->do_upload('img'))
			{
				$data['img_file_errors'] = array('error' => $this->upload_image_lib->display_errors('<li class="error">', '</li>'));
				$img_file = FALSE;
			}
			else
			{
				$img_file = TRUE;
			}
		}
		if($this->form_validation->run() === TRUE && $img_file) {
			$img_name    = "";
			$img_ext     = "";
			if($upload_img_check && $img_file) {
				$this->upload_image_lib->move_file();
				
				$uploaded_img = $this->upload_image_lib->data();
				$img_name     = $uploaded_img['raw_name'];
				$img_ext      = $uploaded_img['file_ext'];
			}
			//exit;			
			$img_title = $this->input->post('img_title');
			$publish   = ($this->input->post('publish') == 'accept' ? 1 : 0);
			if($this->admin->edit_client($client_id, $img_title, $img_name, $img_ext, $publish)) {
				$this->messages->success('This item has been edited successfully');
			}
			else {
				$this->messages->error('Unknown error occured, try again later');
			}
			redirect('/admin/edit_client/' . $client_id);
		}
		$this->load->view('backend/edit_client_view', $data);
	}
	
	function pages($id) {
		if(!is_numeric($id) || !($id >= 1 && $id <= 7)) {
			redirect('admin');
		}
		$this->form_validation->set_rules('text', 'text', 'required');
		if($this->form_validation->run() == TRUE) {
			$text = $this->input->post('text');
			// print __LINE__;
			// exit;
			$updated = array(
							'page_text' => $text
							);
			$array = array('page_id' => $id);
			$this->db->where($array);
			$this->db->update('static_pages', $updated);
			$this->messages->success('The text has been edited successfully');
		}
		$data['id']  = $id;
		$data['row'] = $this->db->get_where('static_pages', array('page_id' => $id))->row();
		$this->load->view('backend/static_pages_view', $data);
	}
	function news() {
		$data['news'] = $this->admin->get_news();
		$this->load->view('backend/news_view', $data);
	}
	// News
	function add_news() {
		$this->form_validation->set_rules('news_title', 'news title', 'required|min_length[5]|max_length[75]|callback_unique_news_title');
		$this->form_validation->set_rules('news_text', 'news text', 'required|min_length[10]');
		$this->form_validation->set_rules('news_img', 'image', '');
		$this->form_validation->set_rules('upload_attach', '', '');
		$this->form_validation->set_rules('publish', 'publish', '');
				
		// Upload new attachment file
		$upload_attach_file = $this->input->post('upload_attach') == 'accept' ? 1 : 0;
		if($upload_attach_file) {
			$attach_file = FALSE;
		} else {
			$attach_file = TRUE;
		}

		$data     = array();
		$img_file = FALSE;

		if($_POST) {
			// Image
			$config = array();
			$config['upload_path']   = $this->root.'uploads/images/news/';
			$config['allowed_types'] = 'jpg|png|gif|jpeg';
			$config['max_width']     = '1170';
			$config['max_height']    = '768';
			$config['max_size']      = '1024'; // In kilobytes (zero for no limit)
			$config['encrypt_name']  = TRUE;
			
			$this->load->library('upload', $config, 'upload_image_lib');
			if(!$this->upload_image_lib->do_upload('news_img'))
			{
				$data['img_file_errors'] = array('error' => $this->upload_image_lib->display_errors('<li class="error">', '</li>'));
			}
			else {
				$uploaded_img = $this->upload_image_lib->data();
				$img_name     = $uploaded_img['raw_name'];
				$img_ext      = $uploaded_img['file_ext'];
				$img_file     = TRUE;
			}
			
			// Attachment file
			if($upload_attach_file) {
				$config = array();
				$config['upload_path']   = $this->root . 'uploads/files/news/';
				$config['allowed_types'] = 'pdf|doc|docx';
				$config['max_size']      = '1024'; // In kilobytes (zero for no limit)
				$config['encrypt_name']  = TRUE;
				
				$this->load->library('upload', $config, 'upload_file_lib');
				if (!$this->upload_file_lib->do_upload('attach_file'))
				{
					$data['attach_file_errors'] = array('error' => $this->upload_file_lib->display_errors('<li class="error">', '</li>'));
					$attach_file = FALSE;
				}
				else
				{
					$attach_file = TRUE;
				}
			}
		}

		if($this->form_validation->run() === TRUE && $img_file && $attach_file) {
			// Upload image
			$this->upload_image_lib->move_file();
			// Resize image
			$config = array();
			$config['image_library']  = 'gd2';
			$config['source_image']   = $this->root.'uploads/images/news/'.$uploaded_img['file_name'];
			$config['create_thumb']   = TRUE;
			$config['maintain_ratio'] = TRUE;
			$config['width']          = 373;
			$config['height']         = 260;
			$config['new_image']      = $this->root.'uploads/images/news/thumb/'.$uploaded_img['file_name'];
			$this->load->library('image_lib', $config);
			$this->image_lib->resize();
			
			$file_name = "";
			$file_ext  = "";
			// Upload attachment file
			if($upload_attach_file) {
				$this->upload_file_lib->move_file();
				$uploaded_file = $this->upload_file_lib->data();
				$file_name     = $uploaded_file['raw_name'];
				$file_ext      = $uploaded_file['file_ext'];
			}
			
			$news_title = $this->input->post('news_title');
			$news_text  = $this->input->post('news_text'); 
			$publish    = ($this->input->post('publish') == 'accept' ? 1 : 0);
			
			if($this->admin->add_news($news_title, $news_text, $img_name, $img_ext, $upload_attach_file, $file_name, $file_ext, $publish)) {
				$this->messages->success('The news has been added successfully');	
			} else {
				$this->messages->error('Unknown error occured, try again later');
			}
			redirect('admin/news');
		}
		$this->load->view('backend/add_news_view', $data);
	}

	function unique_news_title($title) {
		if($this->db->get_where('news', array('title' => $title))->num_rows()) {
			$this->form_validation->set_message('unique_news_title', 'This title is already published');
			return FALSE;
		}
		return TRUE;
	}
	
	function edit_news($news_id) {
		if(!is_numeric($news_id) || !$this->db->get_where('news', array('id' => $news_id))->num_rows()) {
			redirect('admin');
		}
		$data['news'] = $this->db->get_where('news', array('id' => $news_id))->row();
		$img_file    = TRUE;
		$attach_file = TRUE;
		
		$this->form_validation->set_rules('news_title', 'news title', 'required|min_length[5]|max_length[50]|callback_unique_news_title_edit');
		$this->form_validation->set_rules('news_text', 'news text', 'required|min_length[10]');
		$this->form_validation->set_rules('publish', 'publish', '');
		
		$this->form_validation->set_rules('upload_img', ' ', '');
		
		$this->form_validation->set_rules('delete_attach_file', ' ', '');
		$this->form_validation->set_rules('upload_attach_file', ' ', '');
		
		// Upload new image ???
		$upload_img_check = ($this->input->post('upload_img') == 'accept' ? 1 : 0);
		
		// Only Delete current attachment file
		$delete_file_check   = ($this->input->post('delete_attach_file') == 'accept' ? 1 : 0);

		// Replace current attachment file or upload new one
		$upload_attach_check = ($this->input->post('upload_attach_file') == 'accept' ? 1 : 0);

		if($_POST) {
			if($upload_img_check) {
				$config = array();
				$config['upload_path']   = $this->root.'uploads/images/news/';
				$config['allowed_types'] = 'jpg|png|gif|jpeg';
				$config['max_width']     = '1170';
				$config['max_height']    = '768';
				$config['max_size']      = '512'; // In kilobytes (zero for no limit)
				$config['encrypt_name']  = TRUE;
				
				$this->load->library('upload', $config, 'upload_image_lib');
				if ( ! $this->upload_image_lib->do_upload('news_img'))
				{
					$data['img_file_errors'] = array('error' => $this->upload_image_lib->display_errors('<li class="error">', '</li>'));
					$img_file = FALSE;
				}
				else
				{
					$img_file = TRUE;
				}
			}
			if($upload_attach_check) {
				$config = array();
				$config['upload_path']   = $this->root.'uploads/files/news/';
				$config['allowed_types'] = 'pdf|doc|docx';
				$config['max_size']      = '1024'; // In kilobytes (zero for no limit)
				$config['encrypt_name']  = TRUE;
				
				$this->load->library('upload', $config, 'upload_file_lib');
				if (!$this->upload_file_lib->do_upload('news_attach_file'))
				{
					$data['attach_file_errors'] = array('error' => $this->upload_file_lib->display_errors('<li class="error">', '</li>'));
					$attach_file = FALSE;
				}
				else
				{
					$attach_file = TRUE;
				}
			}
		}

		if($this->form_validation->run() === TRUE && $img_file && $attach_file) {
			$img_name    = "";
			$img_ext     = "";
			
			if($upload_img_check && $img_file) {
				$this->upload_image_lib->move_file();
				// Resize image
				$uploaded = $this->upload_image_lib->data();
				$config = array();
				$config['image_library']  = 'gd2';
				$config['source_image']   = $this->root.'uploads/images/news/'.$uploaded['file_name'];
				$config['create_thumb']   = TRUE;
				$config['maintain_ratio'] = TRUE;
				$config['width']          = 373;
				$config['height']         = 260;
				$config['new_image']      = $this->root.'uploads/images/news/thumb/'.$uploaded['file_name'];
				$this->load->library('image_lib', $config);
				$this->image_lib->resize();
				
				$uploaded_img = $this->upload_image_lib->data();
				$img_name     = $uploaded_img['raw_name'];
				$img_ext      = $uploaded_img['file_ext'];
			}
			$attach_name = "";
			$attach_ext  = "";
			if($upload_attach_check && $attach_file) {
				$this->upload_file_lib->move_file();
				$uploaded_file = $this->upload_file_lib->data();
				$attach_name     = $uploaded_file['raw_name'];
				$attach_ext      = $uploaded_file['file_ext'];
			}
			
			//exit;			
			$news_title = $this->input->post('news_title');
			$news_text  = $this->input->post('news_text'); 
			$publish    = ($this->input->post('publish') == 'accept' ? 1 : 0);
			

			if($this->admin->edit_news($news_id, $news_title, $news_text, $img_name, $img_ext, $delete_file_check , $attach_name, $attach_ext ,$publish)) {
				$this->messages->success('This news has been edited successfully');
			}
			else {
				$this->messages->error('Unknown error occured, try again later');
				
			}
			redirect('/admin/edit_news/' . $news_id);
		}
		$this->load->view('backend/edit_news_view', $data);
	}
	
	function unique_news_title_edit($title) {
	    $news = $this->db->get_where('news', array('id' => $this->uri->segment(3)))->row();
		if($news->title == $title) {
			return TRUE;
		}
		else {
			if(!$this->db->get_where('news', array('title' => $title))->num_rows()) {
				return TRUE;
			}
			else {
				$this->form_validation->set_message('unique_news_title_edit', 'This title is already published');
				return FALSE;
			}
		}
	}
	
	function depts() {
		$data['depts'] = $this->db->get('depts')->result();
		$this->load->view('backend/depts_view', $data);
	}
	
	function add_dept() {
		$this->form_validation->set_rules('dept_name', 'department name', 'required|min_length[2]|max_length[20]|callback_unique_dept_name');
		if($this->form_validation->run() === TRUE) {
			$dept_name = $this->input->post('dept_name');
			$dept = array('dept_name' => $dept_name);
			$this->db->insert('depts', $dept);
			if($this->db->affected_rows()) {
				$this->messages->success('This department has been added successfully');
			}
			else {
				$this->messages->error('Unknown error occured, try again later');
			}
			redirect('admin/depts');
		}
		$this->load->view('backend/add_dept_view');
	}

	function unique_dept_name($dept_name) {
		if($this->db->get_where('depts', array('dept_name' => $dept_name))->num_rows()) {
			$this->form_validation->set_message('unique_dept_name', 'You have entered this name earlier');
			return FALSE;
		}
		return TRUE;
	}
	
	function del_dept($dept_id) {
		if(!is_numeric($dept_id) || !$this->db->get_where('depts', array('id' => $dept_id))->num_rows()) {
			redirect('admin');
		}
		if($this->db->get_where('emp', array('dept_id' => $dept_id))->num_rows()) {
			$this->messages->error('You must delete all members of this department before that you can delete it');
		} else {
			if($this->admin->del_dept($dept_id)) {
				$this->messages->success('This department has been deleted successfully');
			}
			else {
				$this->messages->error('Unknown error occurred, try again later');
			}
		}
		redirect('/admin/depts');
	}
	
	function edit_dept($dept_id) {
		if(!is_numeric($dept_id) || !$this->db->get_where('depts', array('id' => $dept_id))->num_rows()) {
			redirect('admin');
		}
		$data['dept'] = $this->db->get_where('depts', array('id' => $dept_id))->row();
		$this->form_validation->set_rules('dept_name', 'department name', 'required|min_length[2]|max_length[20]|callback_unique_dept_name_edit');
		if($this->form_validation->run() === TRUE) {
			$dept_name = $this->input->post('dept_name');
			$update = array('dept_name' => $dept_name);
			$this->db->where('id', $dept_id);
			$this->db->update('depts', $update);
			$this->messages->success('This department has been edited successfully');
			redirect('/admin/depts');
		}
		$this->load->view('backend/edit_dept_view', $data);
	}
	
	function unique_dept_name_edit($name) {
	    $dept = $this->db->get_where('depts', array('id' => $this->uri->segment(3)))->row();
		if($dept->dept_name == $name) {
			return TRUE;
		}
		else {
			if(!$this->db->get_where('depts', array('dept_name' => $name))->num_rows()) {
				return TRUE;
			}
			else {
				$this->form_validation->set_message('unique_dept_name_edit', 'You have entered this name earlier');
				return FALSE;
			}
		}
	}
	function team() {
		$data['members'] = $this->admin->get_team();
		$this->load->view('backend/team_view', $data);
	}
	
	function add_member() {
		$depts = array();
		$result = $this->db->get('depts')->result();
		foreach($result as $row) {
			$depts[$row->id] = $row->dept_name;
		}
		$data['depts'] = $depts;
		
		$this->form_validation->set_rules('emp_name', 'employee', 'required|min_length[5]|max_length[75]|callback_unique_mamber_name');
		$this->form_validation->set_rules('position', 'position', 'required|min_length[5]|max_length[75]');	
		$this->form_validation->set_rules('dept_id', '', '');
		$this->form_validation->set_rules('f_account', 'facebook account', 'min_length[5]|max_length[255]');
		$this->form_validation->set_rules('t_account', 'facebook account', 'min_length[5]|max_length[255]');
		$this->form_validation->set_rules('photo', 'photo', '');		
		$this->form_validation->set_rules('publish', 'publish', '');

		$img_file = FALSE;

		if($_POST) {
			// Image
			$config = array();
			$config['upload_path']   = $this->root.'uploads/images/team/';
			$config['allowed_types'] = 'jpg|png|gif|jpeg';
			$config['max_width']     = '600';
			$config['max_height']    = '600';
			$config['max_size']      = '512'; // In kilobytes (zero for no limit)
			$config['encrypt_name']  = TRUE;
			
			$this->load->library('upload', $config, 'upload_image_lib');
			if(!$this->upload_image_lib->do_upload('photo'))
			{
				$data['img_file_errors'] = array('error' => $this->upload_image_lib->display_errors('<li class="error">', '</li>'));
			}
			else {
				$uploaded_img = $this->upload_image_lib->data();
				$img_name     = $uploaded_img['raw_name'];
				$img_ext      = $uploaded_img['file_ext'];
				$img_file     = TRUE;
			}
		}

		if($this->form_validation->run() === TRUE && $img_file) {
			// Upload image
			$this->upload_image_lib->move_file();
			$emp_name  = $this->input->post('emp_name');
			$position  = $this->input->post('position'); 
			$dept_id   = $this->input->post('dept_id');
			$f_account = $this->input->post('f_account');
			$t_account = $this->input->post('t_account'); 
			$publish   = ($this->input->post('publish') == 'accept' ? 1 : 0);
			if($this->admin->add_member($emp_name, $position, $dept_id, $f_account, $t_account, $img_name, $img_ext, $publish)) {
				$this->messages->success('The employee has been added successfully');	
			} else {
				$this->messages->error('Unknown error occured, try again later');
			}
			redirect('admin/team');
		}
		$this->load->view('backend/add_member_view', $data);
	}
	function unique_mamber_name($emp_name) {
		if($this->db->get_where('emp', array('emp_name' => $emp_name))->num_rows()) {
			$this->form_validation->set_message('unique_mamber_name', 'You have entered this name earlier');
			return FALSE;
		}
		return TRUE;
	}	function edit_member($emp_id) {		if(!is_numeric($emp_id) || !$this->db->get_where('emp', array('id' => $emp_id))->num_rows()) {			redirect('admin');		}		$data['member'] = $this->db->get_where('emp', array('id' => $emp_id))->row();		$img_file       = TRUE;				$depts = array();		$result = $this->db->get('depts')->result();		foreach($result as $row) {			$depts[$row->id] = $row->dept_name;		}		$data['depts'] = $depts;		$this->form_validation->set_rules('emp_name', 'employee', 'required|min_length[5]|max_length[75]|callback_unique_mamber_name_edit');		$this->form_validation->set_rules('position', 'position', 'required|min_length[5]|max_length[75]');			$this->form_validation->set_rules('dept_id', '', '');		$this->form_validation->set_rules('f_account', 'facebook account', 'min_length[5]|max_length[255]');		$this->form_validation->set_rules('t_account', 'facebook account', 'min_length[5]|max_length[255]');		$this->form_validation->set_rules('photo', 'photo', '');				$this->form_validation->set_rules('publish', 'publish', ''); $this->form_validation->set_rules('upload_img', '', '');				$upload_img_check = ($this->input->post('upload_img') == 'accept' ? 1 : 0);				if($_POST && $upload_img_check) {			$config = array();			$config['upload_path']   = $this->root . 'uploads/images/team/';			$config['allowed_types'] = 'jpg|png|gif|jpeg';			$config['max_width']     = '300';			$config['max_height']    = '300';			$config['max_size']      = '512';			$config['encrypt_name']  = TRUE;			$this->load->library('upload', $config, 'upload_image_lib');			if( ! $this->upload_image_lib->do_upload('photo'))			{				$data['img_file_errors'] = array('error' => $this->upload_image_lib->display_errors('<li class="error">', '</li>'));				$img_file = FALSE;			}			else			{				$img_file = TRUE;			}		}		if($this->form_validation->run() === TRUE && $img_file) {			$img_name    = "";			$img_ext     = "";			if($upload_img_check && $img_file) {				$this->upload_image_lib->move_file();								$uploaded_img = $this->upload_image_lib->data();				$img_name     = $uploaded_img['raw_name'];				$img_ext      = $uploaded_img['file_ext'];			}			$emp_name  = $this->input->post('emp_name');			$position  = $this->input->post('position'); 			$dept_id   = $this->input->post('dept_id');			$f_account = $this->input->post('f_account');			$t_account = $this->input->post('t_account');
				 $publish   = ($this->input->post('publish') == 'accept' ? 1 : 0);
				 //echo "($emp_id, $emp_name, $position, $dept_id, $f_account, $t_account, $img_name, $img_ext, $publish)"; exit;
				 if($this->admin->edit_member($emp_id, $emp_name, $position, $dept_id, $f_account, $t_account, $img_name, $img_ext, $publish)) {				$this->messages->success('This item has been edited successfully');
				 }	
				 else {
					$this->messages->error('Unknown error occured, try again later');			
				 }
				 redirect('/admin/edit_member/' . $emp_id);		}		$this->load->view('backend/edit_member_view', $data);	}
	
	
	function unique_mamber_name_edit($name) {
	    $member = $this->db->get_where('emp', array('id' => $this->uri->segment(3)))->row();
		if($member->emp_name == $name) {
			return TRUE;
		}
		else {
			if(!$this->db->get_where('emp', array('emp_name' => $name))->num_rows()) {
				return TRUE;
			}
			else {
				$this->form_validation->set_message('unique_mamber_name_edit', 'This name is already entered');
				return FALSE;
			}
		}
	}
}
/* End of file admin.php */
/* Location: ./application/controllers/backend/admin.php */